#include <classad_distribution.h>

#include "glite/wmsutils/classads/classad_utils.h"

#include "ManipulationExceptions.h"
#include "PrivateAdManipulation.h"
#include "PrivateAttributes.h"

using namespace glite::wmsutils::classads;

namespace glite {
namespace jdl {

  /* Tmpl: include generic for class JDLPrivate */

void set_edg_previous_matches_ex(
  classad::ClassAd& ad,
  std::vector<std::pair<std::string,int> > const& previous_matches
)
{
  std::vector<classad::ExprTree*> expr_list;
  for (std::vector<std::pair<std::string,int> >::const_iterator it = previous_matches.begin();
       it != previous_matches.end(); ++it) {

    classad::ClassAd* ad = new classad::ClassAd;
    ad->InsertAttr("ce_id", it->first);
    ad->InsertAttr("timestamp", it->second);
    expr_list.push_back(ad);

  }

  ad.Insert("edg_previous_matches_ex", classad::ExprList::MakeExprList(expr_list));
}

} // namespace jdl
} // namespace glite

// Local Variables:
// mode: c++
// End:
