GLITE_FLAVOUR=head
REPOSITORY=../../

CC=gcc
CPP=g++
LIBS=
COFLAGS=-O2
//CWFLAGS=-Wall
CWFLAGS=
CIFLAGS=
CMFLAGS=


GLITE_REP=$(REPOSITORY)/stage/
repository=$(REPOSITORY)/repository/
GLOBUS_LOCATION=$(repository)/globus/2.4.3-VDT-1.2.2/rhel30_gcc32/
CLASSAD=$(repository)/classads/0.9.7-opt/rhel30_gcc32
BOOST=$(repository)/boost/1.32.0/rhel30_gcc32/
BOOST=$(repository)/boost/1.32.0-slc3/rhel30_gcc32/
BOOST_FLAVOUR=gcc-mt
ARES=$(repository)/ares/1.1.1/rhel30_gcc32/

CPPUNIT=$(repository)/cppunit/1.10.2/rhel30_gcc32
#EXPAT=
GLOBUS_FLAVOR_THREADS=gcc32dbgpthr

CFLAGS= $(CWFLAGS) $(COFLAGS) $(CIFLAGS) $(CMFLAGS) -DDEBUG \
	-DWANT_NAMESPACES \
	-I$(CLASSAD)/include \
	-I$(BOOST)/include \
	-I$(GLITE_REP)/include \
	-I$(CPPUNIT)/include \
	-I.  glite-wms-jdl-common.cpp

LDFLAGS= -L$(GLOBUS_LOCATION)/lib \
	-L$(GLITE_REP)/lib \
	-L$(CLASSAD)/lib \
	-L$(BOOST)/lib/ \
	-L$(ARES)/lib \
	-L$(CPPUNIT)/lib \
	-lcrypto_$(GLOBUS_FLAVOR_THREADS) \
	-lglite_wms_util \
	-lglite_wmsutils_jobid \
	-lglite_wmsutils_cjobid \
	-lglite_jdl_api_cpp \
	-lglite_wmsutils_classads \
	-lglite_wmsutils_exception \
	-lclassad \
	-lboost_thread \
	-lboost_filesystem \
	-lboost_signals  \
	-lboost_regex \
	-lpthread \
	-lcppunit


EXTENDED=-lglite_wmsui_client \
	-lglite_dgas_jobAuthClient \
	-lglite_dgas_xmlutil \
	-lglite_wmsutils_tls_socket_pp \
	-lglite_wmsutils_tls_gsisocket_pp \
	-lvomsapi \
	-lglite_lb_common_gcc32 \
	-lglite_lb_client_gcc32 \
	-lglite_lb_clientpp_gcc32 \
	-lglite_wms_checkpointing \
	-lglite_wms_logger \
	-lglite_wmsui_partitioner \


all: ad convert parametric collect dagad extract jobad template jsdl test 
param: parametric



ad:
	@echo "compiling ad....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-adtest glite-wms-jdl-adtest.cpp $(LDFLAGS)
	@echo "DONE  glite-wms-jdl-adtest"
convert:
	@echo "compiling convert....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-convertest glite-wms-jdl-convertest.cpp $(LDFLAGS)
	@echo "DONE glite-wms-jdl-convertest"
parametric:
	@echo "compiling parametric....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-parametrictest glite-wms-jdl-parametrictest.cpp $(LDFLAGS)
	@echo "DONE     glite-wms-jdl-parametrictest"
collect:
	@echo "compiling collect....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-collectest glite-wms-jdl-collectest.cpp $(LDFLAGS)
	@echo "DONE     glite-wms-jdl-collectest"
dagad:
	@echo "compiling dagad....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-dagadtest glite-wms-jdl-dagadtest.cpp $(LDFLAGS)
	@echo "DONE         glite-wms-jdl-dagadtest"

extract:
	@echo "compiling extract....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-extract glite-wms-jdl-extract.cpp $(LDFLAGS)
	@echo "DONE         glite-wms-jdl-extract"

jobad:
	@echo "compiling jobad....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-jobadtest glite-wms-jdl-jobadtest.cpp $(LDFLAGS)
	@echo "DONE         glite-wms-jdl-jobadtest"

template:
	@echo "compiling template....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-jdl-template glite-wms-jdl-template.cpp $(LDFLAGS)
	@echo "DONE         glite-wms-jdl-template"

JSDL=-I/usr/include/libxml2 -lxslt
jsdl:
	@echo "compiling glite-wms-jdl-jsdltest....."
	@$(CPP) -Wall -DHAVE_CONFIG_H   $(CFLAGS) $(JSDL)  -o glite-wms-jdl-jsdltest glite-wms-jdl-jsdltest.cpp $(LDFLAGS)
	@echo "DONE  glite-wms-jdl-jsdltest"

test:
	@echo "compiling FromScratchCheck....."
	@$(CPP)  -Wall  -DHAVE_CONFIG_H   $(CFLAGS) -o glite-wms-test jobAdFromScratchCheck.cpp $(LDFLAGS)
	@echo "DONE         jobAdFromScratchCheck"

