/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#include <iostream>
#include <fstream>

#include <classad_distribution.h>

#include "requestad/convert.h"

using namespace std ;
using namespace glite::jdl;
namespace jdl = glite::jdl;

const string   basead( "[ "
		       "  Executable = \"/bin/echo\";"
  		       "  Universe = \"Globus\";"
  		       "  Transfer_Executable = true;"
  		       "  Copy_to_Spool = true;"
  		       "  Arguments = \"Ciao\";"
  		       "  Output = \"/var/tmp/output\";"
		       "  Type = \"job\";"
		       //  		       "  Error = \"/var/tmp/error\";"
  		       "  GlobusScheduler = \"lxde01.pd.infn.it:2119/jobmanager-pbs\";"
  		       "  x509userproxy = \"/tmp/x509up_u723\";"
  		       "  UserSubjectName=\"/C=IT/O=INFN/OU=Personal "
  		       "Certificate/L=Padova/CN=Rosario Peluso/Email=Rosario.Peluso@pd.infn.it\";"
  		       "  dg_jobId = \"Condor_test_0\";"
  		       "  GlobusRSL = \"(queue=pbsque)\";"
  		       "  Log = \"/var/tmp/CondorG.log\";"
		       "];" );

int main( void )
{
  ofstream                 ofs( "/var/tmp/submit.test" );
  classad::ClassAd        *ad;
  classad::ClassAdParser   parser;

  cout << basead << endl;

  ad = parser.ParseClassAd( basead.c_str() );

  if( ad != NULL ) {
    ad->Puke();

    jdl::to_submit_stream( ofs, *ad );
  }
  else cerr << "Parsing error... " << endl;

  ofs.close();

  return 0;
}
