/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/* ************************************************
    Examples Methods
**************************************************/

//For ifStrean

#include "glite/wms/common/utilities/Exceptions.h"
#include "requestad/JobAd.h"
#include "requestad/ExpDagAd.h"
#include "requestad/DAGAd.h"

#include "requestad/JdlAttributeList.h"
#include "requestad/JDLAttributes.h"

// DAGAd test includes (  remove  )
#include "glite/wmsutils/classads/classad_utils.h"
#include "requestad/DAGAd.h"
#include <boost/tuple/tuple.hpp>

using namespace glite::wms::common::utilities ;
using namespace glite::wmsutils::classads ;
using namespace glite::jdl ;
using namespace std ;
using namespace classad ;

/**************************************
*		DAGAD Test
***************************************/
int EXdagad( const string& dagadfile )  {
	try{
		cout << "\n\n\nExpDag  Test:" << dagadfile  <<flush << endl ;
		std::ifstream jdl_in (  dagadfile.c_str()   ) ;
		ExpDagAd  dagad (  jdl_in ) ;
		dagad.setDefaultRank ("-other.GlueCEStateEstimatedResponseTime") ;
		dagad.setDefaultReq   ("other.GlueCEStateStatus == \"Production\"") ;
		dagad.setDefaultValues(true) ;
		cout  << "\n*******\nTo lines representation\n" << dagad.toString ( ExpDagAd::MULTI_LINES ) << "\n*******\nNow Retrieving Submission Strings..." <<endl <<flush;

		vector <string> jdls = dagad.getSubmissionStrings() ;

		dagad.setAttribute (ExpDagAd::EDG_JOBID , "https://ibm139.cnaf.infn.it:9000/6vOY_jPoY4WggxsFN-0U-Q");
		dagad.setAttribute(ExpDagAd::SEQUENCE_CODE, "UI=000003:NS=0000000000:WM=000000:BH=0000000000:JSS=000000:LM=000000:LRMS=000000:APP=000000" );

		vector<string> jobids ;
		cout <<  "\n\n\nNow Inserting JobIds...." << endl ;
		string id = "https://ibm139.cnaf.infn.it:9000/WXosnKEfYuOR7" ;

		for ( unsigned int i = 0 ; i < jdls.size() ; i++ ) {
			cout << "\n * * * Sub Submission String: " << jdls [i] << endl ;
			jobids.push_back (id);
			id += "x" ;
		}

		cout <<  "\n\n\nShow Dependencies....\n" << dagad.showDependencies() <<"\n\n\n" <<endl ;




		dagad.setJobIds(  jobids );
/*
		cout << "Now Retrieving User Tags:" << endl ;
		vector<  pair<  std::string  ,     ExprTree* > > userTags = dagad.getSubAttributes  ( JDL::USERTAGS  ) ;
		for (unsigned int i = 0 ; i < userTags.size() ; i++ ){
			vector< pair< string, classad::ExprTree *> > vect ;
			((classad::ClassAd*)(userTags[i].second))->GetComponents( vect ) ;
			classad::Value val ;
			ClassAd classad ;
			for (unsigned int i = 0 ; i< vect.size() ; i++){
				classad.EvaluateExpr( vect[i].second, val )  ;
			}
		}
*/
		cout  << "\n*******\nTo lines representation:\n" << dagad.toString ( ExpDagAd::MULTI_LINES ) << endl ;
		cout << "\n*******\nDagAd Test Terminated successfully, exiting..." << endl  ;
		return 0;
	} catch (Exception &exc) {
		cout  <<  "\nStack Trace:\n"  ;
		cout << exc.printStackTrace() ;
		cout  << "\nWhat:\n"  ;
		cout << exc.what() ;
		return 1;
	} catch (exception &exc ){
		cout  << "\nstd exception found : What:\n"  ;
		cout << exc.what() ;
		return 1;
	} catch (...) {
		cout  << "\n\n\n WARNING!!!!!\n EXjobad  Unkwnow exception, please contact the developer\nFile: " << __FILE__ << "\nLine: "<< __LINE__<< endl << flush  ;
		return 2;
	}
}


int main(int argc,char *argv[]){
   if (argc < 2 ||  strcmp(argv[1],"--help") == 0)  {
     cout << "Usage : " << argv[0] << "  <JDL DagAd file name> " << endl;
     return 1;
   }
   int ret = 0;
   ret =  EXdagad( argv[1]  );
   cout << "\n" ;
   return ret;
};

