/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/* ************************************************
    Examples Methods
**************************************************/

//For ifStrean

#include "glite/wmsutils/exception/Exception.h"

#include "glite/jdl/JobAd.h"
#include "glite/jdl/ExpDagAd.h"
#include "glite/jdl/DAGAd.h"

#include "glite/jdl/JdlAttributeList.h"
#include "glite/jdl/JDLAttributes.h"

// DAGAd test includes (  remove  )
#include "glite/wmsutils/classads/classad_utils.h"
#include "glite/jdl/DAGAd.h"

#include <boost/tuple/tuple.hpp>

using namespace glite::wmsutils::classads ;
using namespace glite::wmsutils::exception ;
using namespace glite::jdl;
using namespace std ;
using namespace classad ;


/**************************************
*		DAGAD Test
***************************************/
int EXdagad( const string& dagadfile )  {
	try{
		std::ifstream jdl_in (  dagadfile.c_str()   ) ;
		ExpDagAd  dagad (  jdl_in ) ;
		cout <<  dagad.showDependencies() <<endl ;
		return 0;
	} catch (Exception &exc) {
		cout  <<  "\nStack Trace:\n"  ;
		cout << exc.printStackTrace() ;
		cout  << "\nWhat:\n"  ;
		cout << exc.what() ;
		return 1;
	} catch (exception &exc ){
		cout  << "\nstd exception found : What:\n"  ;
		cout << exc.what() ;
		return 1;
	} catch (...) {
		cout  << "\n\n\n WARNING!!!!!\n  Unkwnow exception, please contact the developer\nFile: " << __FILE__ << "\nLine: "<< __LINE__<< endl << flush  ;
		return 2;
	}
}


int main(int argc,char *argv[]){
   if (argc < 2 ||  strcmp(argv[1],"--help") == 0)  {
     cout << "Usage : " << argv[0] << "  <JDL DagAd file name> " << endl;
     return 1;
   }
   int ret = 0;
   ret =  EXdagad( argv[1]  );
   cout << "\n" ;
   return ret;
};

