/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
 * edg-wl-jdl-collect-test.cpp
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 */


#include "glite/wmsutils/exception/Exception.h"
#include "glite/jdl/adconverter.h"
#include "glite/jdl/collectionad.h"
#include "glite/jdl/JDLAttributes.h"
#include "glite/jdl/ExpDagAd.h"


using namespace std ;
using namespace glite::jdl ;

int emulateServerSide(CollectionAd *collect){
	cout << "EMULATE SERVER SIDE!!!" << endl ;
	ExpDagAd *dag = new ExpDagAd(*(AdConverter::collection2dag(collect->toString())));
	dag->setLocalAccess(false);
	cout << "COLLECTION converted into DagAd:\n" << dag->toString() << endl ;
	cout << "Now retrieving submissions..." << endl ;
	dag->getSubmissionStrings();
	cout << dag->toString() << endl ;
	return 0;
}

void convertCollectTest() {
	CollectionAd *collect = AdConverter::createCollectionFromPath("clt/*.jdl");
	cout << "Collection converted: " << collect->toLines() << endl ;
	cout << "getNodeStringValueSSS.........." << endl ;
		std::vector< std::pair<std::string,std::vector< std::string > > > values= collect->getNodeStringValues("inputSandbox");
		for (unsigned int i =0 ; i<values.size();i++){
			vector< string > pire=values[i].second;
			cout << "NODE " << values[i].first<< endl ;;
			for (unsigned int j =0 ; j<pire.size();j++){
				cout << j <<") " << pire[j] << endl;
			}
		}
}


void toBCopiedFileList(const std::string &wmp_uri, const std::string &isb_uri, const std::vector <std::string> &paths){
	std::vector <std::pair<std::string, std::string> > to_bcopied ;
	toBcopied("InputSandbox", paths, to_bcopied, wmp_uri, isb_uri);
	for (unsigned int i = 0 ; i< to_bcopied.size() ; i++){
		cout << "SRC:  " << to_bcopied[i].first  <<"  ###   DEST: " << to_bcopied[i].second << endl ;
	}
}

int main(int argc,char *argv[]){
	try{
		if (argc < 2 ||  strcmp(argv[1],"--help") == 0)  {
			cout << "Usage : " << argv[0] << "  <collection path>  " << endl;
			return 1;
		}
		glite::jdl::CollectionAd *collect = AdConverter::createCollectionFromPath(argv[1]);
		collect->setAttributeExpr("DEFRANK" ,"3");
		collect->setAttributeExpr("DEFREQ" ,"true");
		collect->setLocalAccess(true);
		collect->setDefaultRank(collect->delAttribute("DEFRANK"));
		collect->setDefaultReq(collect->delAttribute("DEFREQ"));
		collect->setAttribute(JDL::VIRTUAL_ORGANISATION,"egee");
		cout << "Lines..." << endl << collect->toLines() <<endl;
		cout << "Checking jdl..." << endl ;
		collect=collect->check();
		cout << "Submission..." <<endl;
		cout << collect->toString() << endl ;
		cout << "files to be retrieved ????..." << endl ;
		if (collect->gettoBretrieved()){
			cout << "There are some file to be retrieved..." << endl ;
			collect->setAttribute("WMPinputsandboxBaseUri", "http://collectionUri");
			string isb_uri=collect->hasAttribute(JDL::ISB_BASE_URI)?collect->getString(JDL::ISB_BASE_URI ):"";
			string wmp_uri=collect->hasAttribute(JDL::WMPISB_BASE_URI)?collect->getString(JDL::WMPISB_BASE_URI ):"";
			toBCopiedFileList(wmp_uri,isb_uri, collect->getStringValue(JDL::INPUTSB));
		}else {cout << "NO!!!" << endl ;}
		return emulateServerSide(collect) ;
		cout << "Submission..." <<endl;
		cout << collect->toString() << endl ;
		
		// cout << "my collect is still over there...." << collect.toLines()<<endl ;
/*
		cout << "getNodeStringValue............." << endl ;
		std::vector< std::string > gnsv = collect.getNodeStringValue("nodeA", "InputSandbox");
		for (unsigned int i =0 ; i<gnsv.size();i++){
			cout << i <<") " << gnsv[i] ;
		}
*/


/*
		cout << "getNodeStringValueSSS.........." << endl ;
		std::vector< std::pair<std::string,std::vector< std::string > > > values= collect.getNodeStringValues("inputSandbox");
		for (unsigned int i =0 ; i<values.size();i++){
			vector< string > pire=values[i].second;
			cout << "NODE " << values[i].first<< endl ;;
			for (unsigned int j =0 ; j<pire.size();j++){
				cout << j <<") " << pire[j] << endl;
			}
		}
		cout << endl ;
*/
// Additional tests...
// convertCollectTest();
		return 0;
	}catch  (glite::wmsutils::exception::Exception &exc){
			cout << "\nOperation not performed\n" ;
			cout <<"Stack...  " << exc.printStackTrace()<<  endl ;
			cout <<"Exc Name  " << exc.getExceptionName()<< endl;
			cout <<"What      " << exc.what()<< endl;
	}catch  (std::exception &exc){
			cout << "\nOperation not performed. std::exception found:\n" ;
			cout <<  exc.what() << endl ;
	}
	return 1 ;
};

