/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
 * AdConverter Class TEST
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 */


#include "glite/wmsutils/exception/Exception.h"
#include "glite/jdl/adconverter.h"
#include "glite/jdl/collectionad.h"
#include "glite/jdl/JobAd.h"
#include "glite/jdl/ExpDagAd.h"
#include "glite-wms-jdl-common.h"

using namespace std ;
using namespace glite::jdl ;



int main(int argc,char *argv[]){

try{
	title("Job Template");
	int type = 0;
	string executable = "/bin/date" ;
	string arguments  = "-u -p";
	string requirements = "other.GlueCEStateStatus == \"Production\"" ;
	string rank = "-other.GlueCEStateEstimatedResponseTime" ;
	string vo  ="EGEE";
	JobAd *jab = AdConverter::createJobTemplate (type, executable, arguments,requirements, rank, vo) ;
	cout << jab->toLines() ;
	title("Job createStringParametricTemplate");
	std::vector<std::string> parametrised ;
	parametrised.push_back("executable");
	parametrised.push_back("inputsandbox");
	std::vector<std::string> parameters;
	parameters.push_back("unparam");
	parameters.push_back("dueparam");
	jab = AdConverter::createStringParametricTemplate(parametrised,parameters,requirements,rank,vo);
	cout << jab->toLines() ;
	title("createIntParametricTemplate");
	int param_number = 3;
	int param_start = 0;
	int param_step = 1;
	jab = AdConverter::createIntParametricTemplate(parametrised,param_number,param_start,param_step,requirements,rank,vo);
	cout << jab->toLines() ;
	title("createDAGTemplate");
	NodeStruct dependencies ;
	ExpDagAd *dagad = AdConverter::createDAGTemplate(dependencies,requirements,rank,vo);
	cout << dagad->toString() << endl ;
	title("createCollectionTemplate");
	CollectionAd *collect = AdConverter::createCollectionTemplate (param_number,requirements,rank,vo);
	cout << collect->toLines() << endl ;



 }catch  (glite::wmsutils::exception::Exception &exc){
         cout << "\nOperation not performed\n" ;
         cout <<"Stack...  " << exc.printStackTrace()<<  endl ;
	 cout <<"Exc Name  " << exc.getExceptionName()<< endl;
	 cout <<"What      " << exc.what()<< endl;
}catch  (std::exception &exc){
         cout << "\nOperation not performed. std::exception found:\n" ;
         cout <<  exc.what() << endl ;
}

return 1 ;
};

