/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/* ************************************************
    Examples Methods
**************************************************/

#include "glite/wms/common/utilities/Exceptions.h"
#include "requestad/JobAd.h"

#include "requestad/JdlAttributeList.h"
#include "requestad/JDLAttributes.h"

using namespace glite::wms::common::utilities ;
using namespace glite::jdl ;
using namespace std ;
using namespace classad ;

int EXjobad(const string& jobadfile )  {
try{
	cout << "\nLoading JobAd from File: " << jobadfile << endl ;
	JobAd jab;
	jab.fromFile(jobadfile);

	jab.setDefaultRank("5" );
	jab.setDefaultReq("True") ;

	cout << "\nDone.\nJOBAD  Lines Representation:->"<< flush << jab.toLines() << endl ;
	cout << "\nJOBAD  Once AGAIN!! Lines Representation:->"<< flush << jab.toLines() << endl ;
	cout << "\nJOBAD Submission String->" << flush << jab.toSubmissionString() << endl ;
	cout << "\nJOBAD  Once AGAIN!! Lines Representation:->"<< flush << jab.toLines() << endl ;
	cout << "\nJOBAD One more Submission String->"<< flush  << jab.toSubmissionString() << endl ;
} catch (Exception &exc) {
	cout  <<  "\nStack Trace:\n"  ;
	cout << exc.printStackTrace() ;
	cout  << "\nWhat:\n"  ;
	cout << exc.what() ;
	return 1;
} catch (exception &exc ){
	cout  << "\nstd exception found : What:\n"  ;
	cout << exc.what() ;
	return 2;
} catch (...) {
	cout  << "\n\n\n WARNING!!!!!\nUnkwnow exception, please contact the developer\n"  ;
	return 3;
}
	return 0;
}
int main(int argc,char *argv[]){
   if (argc < 2 ||  strcmp(argv[1],"--help") == 0)  {
     cout << "Usage : " << argv[0] << "  <JDL file>" << endl;
     return 1;
   }
   int ret = 0;
   ret =  EXjobad( argv[1]  );
   cout << "\n" ;
   return ret;
};

