/*
Copyright (c) Members of the EGEE Collaboration. 2004.
See http://www.eu-egee.org/partners/ for details on the
copyright holders.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
 * glite-dag-test.cpp
 * Copyright (c) 2001 The European Datagrid Project - IST programme, all rights reserved.
 * Contributors are mentioned in the code where appropriate.
 */


#include "glite/wmsutils/exception/Exception.h"
#include "glite/wmsutils/jobid/JobId.h"
#include "glite/jdl/JobAd.h"
#include "glite/jdl/ExpDagAd.h"
#include "glite/jdl/DAGAd.h"
#include "glite/wmsui/partitioner/Partitioner.h"

using namespace std ;
using namespace glite::jdl ;

int main(int argc,char *argv[]){

try{
   if (argc < 2 ||  strcmp(argv[1],"--help") == 0)  {
                cout << "Usage : " << argv[0] << "  <JDL file> " << endl ; 
                return 1;
   }
   glite::jdl::Ad jab;
   // read JDL
   jab.fromFile ( argv[1] ) ;
   std::vector <std::string>  jobids ;
   jobids.push_back("https://gundam.cnaf.infn.it:9000/kgYNFUGEk60Z4icfucH7ig");
   jobids.push_back("https://gundam.cnaf.infn.it:9000/zx5ND75DsRQjgLRqNf0FNg");
   jobids.push_back("https://gundam.cnaf.infn.it:9000/kgYNFUGEk60Z4icfPAQGA6");
   jobids.push_back("https://gundam.cnaf.infn.it:9000/zx5ND75DsRQjgLRqBNghTU");
   jobids.push_back("https://gundam.cnaf.infn.it:9000/kgYNFUGEk60Z4icfaf7GHO");
   jobids.push_back("https://gundam.cnaf.infn.it:9000/zx5ND75DsRQjgLRqP67aaY");
   cout << "CREATING PARTITIONER...." << endl ;
   glite::wmsui::partitioner::Partitioner part ( jab.ad(),jobids);
   cout << "CREATING DAG....." <<endl ;
   part.createDag();
   cout << "DONE (success)" << endl ;
   return 0;
 }catch  (glite::wmsutils::exception::Exception &exc){
         cout << "\nOperation not performed\n" ;
         cout <<  exc.printStackTrace();
 }catch  (std::exception &exc){
         cout << "\nOperation not performed. std::exception found:\n" ;
         cout <<  exc.what() << endl ;
}

return 1 ;
};

